/*------------------------------------------------------------File: bb.h------*/
/******************************************************************************/
/*                                                                            */
/*                                                                            */
/*				Vartalaap				                                      */
/*----------------------------------------------------------------------------*/
/*                  Multimedia Multiparty  Conferencing System                */
/*									                                          */
/*	Written by:							                                      */
/*                      Vijay Talati                                          */
/*                      ERNet Lab.                                            */
/*									                                          */
/*		Department of Computer Science and Engineering		                  */
/*		Indian Institute of Technology, Bombay 400076.		                  */
/*									                                          */
/******************************************************************************/

/*
*	This file contains definitions of data structures required by
*	program VARTALAAP and specifically related to the blackboard
*/
#include <stdio.h>
#include <errno.h>
#include <sys/param.h>
#include <fcntl.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/cursorfont.h>
#include <xview/xview.h>
#include <xview/frame.h>
#include <xview/panel.h>
#include <xview/openmenu.h>
#include <xview/textsw.h>
#include <xview/canvas.h>
#include <xview/xv_xrect.h>
#include <xview/scrollbar.h>
#include <xview/server.h>
#include <xview/seln.h>
#include <xview/notice.h>
#include <xview/cursor.h>
#include <xview/font.h>

/* The blackboard structure */
struct {
	Pixmap	bb_pixmap ;				/* The pixmap*/
	GC	bb_gc ;						/* The gc*/
	GC	bb_bgc ;					/* The background gc*/
	Canvas	bb_canvas ;				/* The canvas*/
	Panel	bb_panel ;				/* The top panel for buttons*/
	Frame	bb_frame ;				/* The whole frame*/
	Panel_item	infotxt ;			/* The Item for displaying text in Panel*/
	Panel_item	object_indicator ;	/* Indicates the currently selected object*/
	}BBoard [VNGROUPS] ;

#define	MAX_PTS	30

struct{
	short	type ;					/* The Object type */
	short	piv_x ;					/* Pivot pt, x coord*/
	short	piv_y ;					/* Pivot pt, y coord*/
	short	current_x ;				/* Moving pt, x coord*/
	short	current_y ;				/* Moving pt, y coord*/
	short	number_of_points ;		/* Number of pts forming the object*/
	short	points [MAX_PTS]  ;		/* Array of points*/
	short	current_point ;			/* Current Point number */
	}	BBoardObj[VNGROUPS] ; 


int	CurrBBoardObj[VNGROUPS] ;

int	DrawingOn[VNGROUPS] ;
int	GRID[VNGROUPS] ;

/*Cursors*/
Cursor	top_left ;
Cursor	bottom_right ;
Cursor	circle_cursor ;

#define	CIRC		2
#define	ELLIPSE		3
#define	POLYGON		4
#define	POLYLINE 	5
#define	SPLINE 		6
#define	TEXT 		7
#define	ERASE 		8
#define	GRID_STEP	20

#define	BACKSPACE 	1
#define	DELETE 		1
#define	ENTER 		13

/* Fill Styles */
#define	SOLID			FillSolid
#define	TILED			FillTiled
#define	STIPPLED		FillStippled
#define	OPAQUESTIPPLED	FillOpaqueStippled

#define	MARK_HEIGHT		12
	
int	Fill_Style[VNGROUPS] ;
int	Line_Style[VNGROUPS] ;
int	Curr_Color[VNGROUPS] ;
int	Line_Width[VNGROUPS] ;
int	Font_Family[VNGROUPS] ;
int	Font_Style[VNGROUPS] ;
int	Font_Size[VNGROUPS] ;
int	InTextMode[VNGROUPS] ;

XFontStruct	*cur_font[VNGROUPS] ;
int	cur_char_width[VNGROUPS] ;
int	cur_char_height[VNGROUPS] ;
int	rcv_char_width[VNGROUPS] ;
#define	MAX_BB_TEXT	100 
char	*bb_text_string[VNGROUPS] ;

Pixmap	fill_tile [VNGROUPS];
Pixmap	rfill_tile [VNGROUPS];
Pixmap	erasetile ;
/*------------------------------------------------------------End of bb.h------*/
