/*
 * This routines are from xv ver 2.21 by John Bradley.
 */
/*
 * Copyright 1989, 1990, 1991, 1992 by John Bradley and
 *                       The University of Pennsylvania
 *
 * Permission to use, copy, and distribute for non-commercial purposes,
 * is hereby granted without fee, providing that the above copyright
 * notice appear in all copies and that both the copyright notice and this
 * permission notice appear in supporting documentation.
 *
 * The software may be modified for your own purposes, but modified versions
 * may not be distributed.
 *
 * This software is provided "as is" without any expressed or implied warranty.
 *
 * The author may be contacted via:
 *    US Mail:   John Bradley
 *               GRASP Lab, Room 301C
 *               3401 Walnut St.
 *               Philadelphia, PA  19104
 *
 *    Phone:     (215) 898-8813
 *    EMail:     bradley@cis.upenn.edu
 */


#include	<X11/Xlib.h> 
#include	<X11/Xutil.h>
#include	<xview/xview.h>
#include	<xview/frame.h>
#include	<xview/panel.h>
#include	<xview/openmenu.h>
#include	<xview/textsw.h>
#include	<xview/canvas.h>
#include	<xview/xv_xrect.h>
#include	<xview/scrollbar.h>
#include	<xview/cursor.h>

#include "vartalaap.h"
#include "posdefs.h"

#include "../common/talklib.h"
#include "../common/protodefs.h"



/*******************************************/
int LoadXBM(fname)
     char *fname;
/*******************************************/
{
  FILE  *fp;
  int    c, c1;
  int    i, j, k, bit, w, h;
  unsigned char  *pix;
  long   filesize;
  char   line[256];
  unsigned char   hex[256];

  k = 0;

  fp=fopen(fname,"r");
  if (!fp) return 1;

  /* figure out the file size (for Informational Purposes Only) */
  fseek(fp, 0L, 2);
  filesize = ftell(fp);
  fseek(fp, 0L, 0);



  /* read width:  skip lines until we hit a #define */
  while (1) {
    if (!fgets(line,256,fp))
      return(XBMError("EOF reached in header info."));

    if (strncmp(line,"#define",7)==0) {
      if (sscanf(line,"#define %*s %d", &w) != 1)
        return(XBMError("Unable to read 'width'"));
      else break;
    }
  }  


  /* read height:  skip lines until we hit another #define */
  while (1) {
    if (!fgets(line,256,fp))
      return(XBMError("EOF reached in header info."));

    if (strncmp(line,"#define",7)==0) {
      if (sscanf(line,"#define %*s %d", &h) != 1)
        return(XBMError("Unable to read 'height'"));
      else break;
    }
  }  



  /* scan forward until we see the first '0x' */
  c = getc(fp);  c1 = getc(fp);
  while (c1!=EOF && !(c=='0' && c1=='x') ) { c = c1;  c1 = getc(fp); }
  if (c1==EOF)
    return(XBMError("No bitmap data found"));


  /* load up the stuff XV expects us to load up */
/**

  SetDirRButt(F_FORMAT, F_XBM);
  SetDirRButt(F_COLORS, F_BWDITHER);

  SetISTR(ISTR_FORMAT,"X11 Bitmap  (%ld bytes)", filesize);
  sprintf(formatStr, "%dx%d X11 Bitmap.",w,h);
**/

  pic = (unsigned char *) calloc(w*h,1);
  if (!pic) printf("couldn't malloc 'pic'");

  pWIDE = w;  pHIGH = h;

  /* B/W bitmaps have a two entry colormap */
  r[0] = g[0] = b[0] = 255;     /* 0 = white */
  r[1] = g[1] = b[1] = 0;       /* 1 = black */


  /* initialize the 'hex' array for zippy ASCII-hex -> int conversion */

  for (i=0; i<256; i++) hex[i]=0;
  for (i='0'; i<='9'; i++) hex[i] = i - '0';
  for (i='a'; i<='f'; i++) hex[i] = i + 10 - 'a';
  for (i='A'; i<='F'; i++) hex[i] = i + 10 - 'A';

  /* read/convert the image data */


  for (i=0, pix=pic; i<h; i++)
    for (j=0,bit=0; j<w; j++, pix++, bit = (++bit)&7) {

      if (!bit) {
        /* get next byte from file.  we're already positioned at it */
        c = getc(fp);  c1 = getc(fp);
        if (c<0 || c1<0) {
          /* EOF: break out of loop */
          c=c1='0'; i=h; j=w;
          XBMError("The file would appear to be truncated.");
        }

        k = (hex[c] << 4) + hex[c1];

        /* advance to next '0x' */
        c = getc(fp);  c1 = getc(fp);
        while (c1!=EOF && !(c=='0' && c1=='x') ) { c = c1;  c1 = getc(fp); }
      }

      *pix = (k&1) ? 1 : 0;
      k = k >> 1;
    }

  fclose(fp);

  return 0;
}


/* VIJAY: Added this  */
int XBMError( str)
char	*str ;
{

	errmsg(str) ;
	return(-1) ;
}	


