/*----------------------------------------------------------File: inc.h-----*/
/******************************************************************************/
/*                                                                            */
/*                                                                            */
/*                              Vartalaap                                     */
/*----------------------------------------------------------------------------*/
/*                  Multimedia Multiparty  Conferencing System                */
/*                                                                            */
/*                                                                            */
/*                  Written by:                                               */
/*                            Yezdezard Lashkari                              */
/*                            Viswanath Ramachandran                          */
/*                            Sanjay Malpani                                  */
/*                             VIJAY TALATI                                   */
/*                             ERNet Lab,                                     */
/*                             Department of Computer Science,                */
/*                             Indian Institute of Technology, Bombay 400076. */
/*                             E-mail : vijay@gateway.iitb.ernet.in           */
/*                                                                            */
/******************************************************************************/

#include	<stdio.h>
#include	<fcntl.h>
#include	<errno.h>

#include	<sys/time.h>		/* For struct timeval */
#include	<sys/param.h>		/* For MAXHOSTNAMELEN*/
#include	<sys/types.h>
#ifdef DRS
#include	<sys/mntent.h>		/* For bzero, bcopy .. etc */
#endif
#include	<sys/socket.h>
#ifndef	SCO_UNIX
#include	<sys/un.h>
#endif
#include	<sys/ioctl.h>
#include	<netinet/in.h>
#include	<netdb.h>

int	DebuggingFlag ; 			/*the debug flag */
#define	DL3		7
#define	DL2		3
#define	DL1		1

/*	
 *	Global Macros
 */

#define	ERROR(str)	fprintf(stderr,"[ERROR]:%s\n",str)
#define	ERROR_VAL(f)	{ fprintf f ; fflush(stderr) ;}
#define	FATAL(str)	{fprintf(stderr,"[FATAL]:%s\n",str); exit(1);}
#define	SYSFATAL(str)	{perror(str); exit(1);}
#define	SYSERR(str)	perror(str) 

#define	MSG(str)	fprintf(stderr,"[TALK]:%s\n",str)
#define	ENTER_PROC(str)	fprintf(stderr,"[Entered]:%s\n",str)
#define	LEAVE_PROC(str)	fprintf(stderr,"[Left]:%s\n",str)

#define	DEBUG_LEVEL1(f)\
{\
	if (DebuggingFlag & DL1)\
	{ fprintf f ; fflush(stderr) ;}\
}

#define	DEBUG_LEVEL2(f)\
{\
	if (DebuggingFlag & DL2)\
	{ fprintf  f ; fflush(stderr) ;}\
}

#define	DEBUG_LEVEL3(f)\
{\
	if (DebuggingFlag & DL3)\
	{ fprintf  f ; fflush(stderr) ;}\
}

/*
 *	Global types
 */

#define	FD	int		/* File descriptor */
#define	Bool	int		/* TRUE or FALSE   */

#define	Status	int

/*
 *	Global defns
 */


#define		SERVER_BASE_PORT	5000	/* Base addr of well known port*/
#define		SERVER_IMAGE_BASE_PORT	5600	/* Base addr of well known port*/
			
#ifndef	MAXNAMESZ
#define	MAXNAMESZ	255
#endif	/* MAXNAMESZ */


#ifndef	TRUE
#define	TRUE	1
#endif	/* TRUE */

#ifndef	FALSE
#define	FALSE	0
#endif	/* FALSE */

/********************  Status codes for returning *****************************/

#ifndef	SUCCESS
#define	SUCCESS	1
#endif	/* SUCCESS */

#ifndef	FAILURE
#define	FAILURE	0
#endif	/* FAILURE */

#define NONUNIQUE_NAME 2

#define INVALID_ID 3	

#define INVALID_NAME 4

/******************************************************************************/

#ifndef	SO_DONTLINGER
#define	SO_DONTLINGER
#endif

#ifndef	UNIX_WRK_DIR
#define	UNIX_WRK_DIR	"/tmp/"
#endif

/* the max number of groups that vartalaap allows */
#define VNGROUPS 3


#ifndef	DRS
#define	EBADFD 19
#endif
