/*--------------------------------------------------------File: talklib.h-----*/
/******************************************************************************/
/*                                                                            */
/*                                                                            */
/*                              Vartalaap                                     */
/*----------------------------------------------------------------------------*/
/*                  Multimedia Multiparty  Conferencing System                */
/*                                                                            */
/*                                                                            */
/*                  Written by:                                               */
/*                            Yezdezard Lashkari                              */
/*                            Viswanath Ramachandran                          */
/*                            Sanjay Malpani                                  */
/*                             VIJAY TALATI                                   */
/*                             ERNet Lab,                                     */
/*                             Department of Computer Science,                */
/*                             Indian Institute of Technology, Bombay 400076. */
/*                             E-mail : vijay@gateway.iitb.ernet.in           */
/*                                                                            */
/******************************************************************************/

/*
 * This is the header file to be include by clients that want
 * to use the N party talk servers facility.
 */

 /* 	Return values of various library functions 	*/


 /* Extern declarations for the various library routines */
#define	Status int

 extern Status T_init_talk_lib();
 extern Status T_make_new_group();
 extern Status T_HistoryReq();
 extern Status T_alias_group();
 extern Status T_unalias_group();
 extern Status T_get_id();
 extern Status T_join();
 extern Status T_leave();
 extern Status T_send();
 extern Status T_receive();

 /* 	Maximum length of an alias permitted 	*/

#define	_MAXLEN		26	/* 25 chars plus \0 */

/*	Some data structures for receiving messages 	*/

typedef	struct	clpkt {
	unsigned short	grp_id ;
	int	pkt_type ;
	
	/* For image data*/
	int	pkts_left ;
	unsigned	short	image_type ;
	/* For text data ( also for image )  */
	int	nBytes ;
	unsigned short	userid ;
	char	*msg ;
	char 	*username ;

	/* For annotate data */
	int	msgnum ;
	int	from ;
	int	to ;

	/* For image mark */
	int	index ;
	int	mtype ;
	int	startx ;
	int	starty ;
	int	endx ;
	int	endy ;

	/* For BlackBoard Objects*/
	int	obj_type ;
	int	lstyle ;
	int	fstyle ;
	int	lwidth ;
	int	color ;
	
	/* For BlackBoard char */
	int	font_style ;
	int	font_family ;
	int	font_size ;
	short	pos_x ;
	short	pos_y ;
	char	letter ;
	
	} CL_PKT ;

typedef	struct	pdata {

		int	no_of_peers ;
		int	*peer_id ;
		char	*peer_info;

		} P_Data ;
	

#define		POLL	0	/* poll for msgs reqd */

int		ServerPort ;
char	ServerName[30] ;/*WORKHERE*/ 

int		MessageNumber[VNGROUPS] ;
int		ImageIndex	[VNGROUPS] ;
int		StartMessageNumber[VNGROUPS] ;
int		StartImageIndex[VNGROUPS] ;
