/*----------------------------------------------------------File: utils.c-----*/
/******************************************************************************/
/*                                                                            */
/*                                                                            */
/*                              Vartalaap                                     */
/*----------------------------------------------------------------------------*/
/*                  Multimedia Multiparty  Conferencing System                */
/*                                                                            */
/*                                                                            */
/*                  Written by:                                               */
/*                            Yezdezard Lashkari                              */
/*                            Viswanath Ramachandran                          */
/*                            Sanjay Malpani                                  */
/*                             VIJAY TALATI                                   */
/*                             ERNet Lab,                                     */
/*                             Department of Computer Science,                */
/*                             Indian Institute of Technology, Bombay 400076. */
/*                             E-mail : vijay@gateway.iitb.ernet.in           */
/*                                                                            */
/******************************************************************************/

/*
 *	Utility functions usable by all files
 */

#include	"inc.h"

/*
 *	'Safer' malloc(), calloc() and free()
 */

#include	<stdlib.h>

/*----------------------------------------------------------Calloc()----------*/
char 	*Calloc(nelem,elemsz)
unsigned int nelem, elemsz;
{
	char *p;

	if((p = calloc((unsigned int)nelem, (unsigned int)elemsz)) 
					==(void*)NULL)
		FATAL("Couldnt calloc");
	/* else */

	return(p);
}


/*----------------------------------------------------------Malloc()----------*/
char	*Malloc(n)
int	n;
{
	char	*p;

	DEBUG_LEVEL3((stderr,"IN MALLOC\n") );

	if((p = (char *)malloc( n )) == NULL)
	{
		FATAL("malloc failed");
	}
	/* else*/


	return(p);
}


/*------------------------------------------------------------Free()----------*/
void	Free(p)
char	*p;
{

	free(p);


}

/*
 *	Signal handling routines
 */

#include	<signal.h>

/*-------------------------------------------------------SignalURG()----------*/
void	SignalURG()
{
	DEBUG_LEVEL1((stderr,"==> SIGURG received"));
}

/*-------------------------------------------------------SignalPIPE()---------*/
void	SignalPIPE()
{
	DEBUG_LEVEL1((stderr,"==> SIGPIPE received"));
}

/*-------------------------------------------------------SignalTSTP()---------*/
void	SignalTSTP()
{
	DEBUG_LEVEL1((stderr,"==> SIGTSTP received"));
}

/*-------------------------------------------------------SignalCONT()---------*/
void	SignalCONT()
{
	DEBUG_LEVEL1((stderr,"==> SIGCONT received"));
}


/*------------------------------------------------SetSignalHandling()---------*/
void	SetSignalHandling()
{
	signal(SIGPIPE,SignalPIPE);
	signal(SIGTSTP,SignalTSTP);
	signal(SIGCONT,SignalCONT);

}
/*----------------------------------------------End of utils.c ---------------*/
