/*------------------------------------------------------------join.c----------*/
/******************************************************************************/
/*                                                                            */
/*                                                                            */
/*                                Vartalaap                                   */
/*----------------------------------------------------------------------------*/
/*                     Multimedia Conferencing Software                       */
/*                                                                            */
/*                                                                            */
/*        Written by:                                                         */
/*                        Yezdezard Lashkari                                  */
/*                        Viswanath Ramachandran                              */
/*                        Sanjay Malpani                                      */
/*                 and                                                        */
/*                        Vijay Talati                                        */
/*                                                                            */
/*                                                                            */
/*                Department of Computer Science and Engineering              */
/*                Indian Institute of Technology, Bombay 400076.              */
/*                                                                            */
/******************************************************************************/

/*	to join a talk group	*/

#include	"../common/inc.h"
#include	"../common/protodefs.h"

#define		EXTERN	extern

#include	"clientlib.h"

/*------------------------------------------------------------T_join()--------*/
Status	T_join(gid , uid_ptr, pno_ptr,dptr)
int		gid;		/* the group id */
int		*uid_ptr;
int		*pno_ptr ;
CL_PKT	*dptr[]	;
{
	FD 				fd = L_sock ;
	JoinGroupReply	rep;
	T_GenericReply	genrep;
	int				i ;
	T_Data			tdata ;

	/* First check for dirty business by the client */
	if(INIT_LIB_FLAG == FALSE)
		FATAL("Library structures NOT initialised");

	(void)LL_SendJoinGroupReq(fd, gid);
	
	DEBUG_LEVEL2((stderr,"Waitng for JoinGroup Reply"));

	if(_Reply(fd, _JoinGroupReply, &genrep) != SUCCESS)
	{
		ERROR("Wrong reply recd ");
		return(_OtherFailure);
	}

	/* else -- process it */

	bcopy((char *)&genrep, (char *)&rep, sizeof(T_GenericReply));

	if(rep.success == FALSE)
	{
		ERROR("JoinGroup Request Failed");
		return(rep.errCode);
	}

	/* Read the info data of peer users*/
	for (i=0 ; i <rep.no_of_peers; i++)
	{
		if (!ReadBuffer(fd, (char *)&genrep, sizeof(T_GenericReply) ))
			return(_OtherFailure) ;
		if(genrep.type != _T_Data)
			return(_OtherFailure) ;

		bcopy((char *)&genrep, (char *)&tdata, sizeof(T_GenericReply)) ;
		
		dptr[i] = (CL_PKT *)Malloc(sizeof(CL_PKT)) ;
		if (DoPackData(&tdata, fd, dptr[i]) != SUCCESS)
			return(_OtherFailure) ;
		dptr[i]->index = rep.ImgIndx ;
	}
		
	(*uid_ptr) = rep.userid ;
	(*pno_ptr) = rep.no_of_peers ;

/*WORKHERE*/
	/* Set the Message number */
	MessageNumber [gid] = rep.MsgNum ;
	ImageIndex [gid] = rep.ImgIndx ;
	StartMessageNumber [gid] = rep.MsgNum ;
	StartImageIndex [gid] = rep.ImgIndx ;

	return(_NoError);

}

/*-----------------------------------------------------End of join.c()--------*/
