/*----------------------------------------------------libutils.c--------------*/
/******************************************************************************/
/*                                                                            */
/*                                                                            */
/*                                Vartalaap                                   */
/*----------------------------------------------------------------------------*/
/*                     Multimedia Conferencing Software                       */
/*                                                                            */
/*                                                                            */
/*        Written by:                                                         */
/*                        Yezdezard Lashkari                                  */
/*                        Viswanath Ramachandran                              */
/*                        Sanjay Malpani                                      */
/*                 and                                                        */
/*                        Vijay Talati                                        */
/*                                                                            */
/*                                                                            */
/*                Department of Computer Science and Engineering              */
/*                Indian Institute of Technology, Bombay 400076.              */
/*                                                                            */
/******************************************************************************/

/*
 *	Utility functions usable by all files
 */

#include	"../common/inc.h"

/*
 *	'Safer' malloc(), calloc() and free()
 */

#include	<stdlib.h>

/*----------------------------------------------------Realloc()---------------*/
char	*Realloc(ptr, size)
char	*ptr;
unsigned int size;
{
	char 	*p;

	if(!(p = (char *) realloc((char *)ptr, (unsigned int)size)))
		FATAL("Couldnt realloc");
	/* else */

	return(p);
}

/*----------------------------------------------------Calloc()---------------*/
char 	*Calloc(nelem,elemsz)
unsigned int nelem, elemsz;
{
	char *p;

	if(!(p = calloc((unsigned int)nelem, (unsigned int)elemsz)))
		FATAL("Couldnt calloc");
	/* else */

	return(p);
}

/*----------------------------------------------------Malloc()---------------*/
char	*Malloc(n)
int	n;
{
	char	*p;

	if((p = (char *)malloc( n )) == NULL)
		FATAL("malloc failed");
	/* else*/

	return( p );
}


/*-------------------------------------------------------Free()---------------*/
void	Free(p)
char	*p;
{

	free(p);
}

/*-------------------------------------------------------End of libutils.c----*/
