/*--------------------------------------------------mknewgrp.c----------------*/
/******************************************************************************/
/*                                                                            */
/*                                                                            */
/*                                Vartalaap                                   */
/*----------------------------------------------------------------------------*/
/*                     Multimedia Conferencing Software                       */
/*                                                                            */
/*                                                                            */
/*        Written by:                                                         */
/*                        Yezdezard Lashkari                                  */
/*                        Viswanath Ramachandran                              */
/*                        Sanjay Malpani                                      */
/*                  and                                                       */
/*                        Vijay Talati                                        */
/*                                                                            */
/*                                                                            */
/*                Department of Computer Science and Engineering              */
/*                Indian Institute of Technology, Bombay 400076.              */
/*                                                                            */
/******************************************************************************/

/* create a new talk group */

#include	"../common/inc.h"
#include	"../common/protodefs.h"

#define		EXTERN	extern

#include	"clientlib.h"


/*--------------------------------------------------T_make_new_group()---------*/
Status	T_make_new_group(gid_ptr, uid_ptr)
int	*gid_ptr;	/* pointer to new id assigned */
int	*uid_ptr ;
{
	FD	fd = L_sock ;
	T_GenericReply	genrep;
	MakeGroupReply rep;


	/* 	First check for dirty business by the client */
	if(INIT_LIB_FLAG == FALSE)
		FATAL("Library structures NOT initialised");

	(void)LL_SendMakeGroupReq(fd);
	
	DEBUG_LEVEL2((stderr,"Waitng for MakeGroup Reply"));

	if(_Reply(fd, _MakeGroupReply,&genrep ) != SUCCESS)
	{
		ERROR("Wrong reply recd ");
		return(_OtherFailure);
	}

	  /* else -- process it */

	bcopy((char *)&genrep, (char *)&rep, sizeof(T_GenericReply));

	if(rep.success == FALSE)
	{
		ERROR("Make Group Request Failed");
		return(rep.errCode);
	}

	/* else -- it's cool */

	(*gid_ptr ) = rep.gid ;
	(*uid_ptr) = rep.userid ;

	/*Set the message number */
	MessageNumber[rep.gid] = rep.MsgNum ;
	ImageIndex[rep.gid] = rep.ImgIndx ;
	StartMessageNumber[rep.gid] = MessageNumber[rep.gid] ;
	StartImageIndex[rep.gid] = rep.ImgIndx ;

	return(_NoError);

}

/*--------------------------------------------------End of mknewgrp.c----------*/
